<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * @package    lnApp
 * @subpackage Auth
 * @category   Models
 * @author     Deon George
 * @copyright  (c) 2010 Deon George
 * @license    http://dev.leenooks.net/license.html
 */
class Model_Group extends Model_Auth_RoleDefault {
	// Relationships
	protected $_has_many = array(
		'account'=>array('through'=>'account_group'),
	);

	protected $_sorting = array(
		'name'=>'ASC',
	);

	// Validation rules
	protected $_rules = array(
		'name' => array(
			'not_empty'  => NULL,
			'min_length' => array(4),
			'max_length' => array(32),
		),
		'description' => array(
			'max_length' => array(255),
		),
	);

	protected $_display_filters = array(
		'status'=>array(
			array('StaticList_YesNo::display',array(':value')),
		),
	);
}
?>
