<?php
/**
 * AgileBill - Open Billing Software
 *
 * This body of work is free software; you can redistribute it and/or
 * modify it under the terms of the Open AgileBill License
 * License as published at http://www.agileco.com/agilebill/license1-4.txt
 *
 * Originally authored by Tony Landis, AgileBill LLC
 * Recent modifications by Deon George
 *
 * @author Deon George <deonATleenooksDOTnet>
 * @copyright 2009 Deon George
 * @link http://osb.leenooks.net
 *
 * @link http://www.agileco.com/
 * @copyright 2004-2008 Agileco, LLC.
 * @license http://www.agileco.com/agilebill/license1-4.txt
 * @author Tony Landis <tony@agileco.com>
 * @package AgileBill
 */

/**
 * The main AgileBill CORE Database DELETE Method
 *
 * @package AgileBill
 * @subpackage Core:Database
 * @uses CORE_Trigger
 */

function CORE_database_delete($VAR,$construct,$type) {
	global $C_debug,$C_translate;

	$db = &DB();

	# Execute the SQL
	$result = $db->Execute(sqlDelete($db,$construct->table,array('id'=>$VAR['id'])));

	# Alert
	$C_debug->value['id'] = $VAR[$construct->table.'_id'];
	$C_debug->value['module_name'] = $C_translate->translate('menu',$construct->module,'');
	$C_debug->alert($C_translate->translate('alert_delete_id','',''));

	# error reporting
	if ($result === false) {
		global $C_debug;
		$C_debug->error(__FILE__,__METHOD__,$db->ErrorMsg());
	}


	if (isset($construct->trigger[$type])) {
		include_once(PATH_CORE.'trigger.inc.php');
		$trigger = new CORE_trigger;

		$trigger->trigger($construct->trigger[$type],0,$VAR);
	}
}
?>
